import java.util.List;
import java.util.ArrayList;
import java.util.HashMap;

import javafx.collections.ObservableList;
import javafx.scene.Group;
import javafx.scene.Node;

/**
 * 3DplNX
 * <pre>
 * Ԃ̐sAKXAm[hrun\bhĂяo܂B
 * L[̉Ԃ𐧌䂵܂B
 * </pre>
 */
public class PRPanel3D extends Group implements PRConstant {

	/** AvP[V */
	private		PRApplication			application				= null;

	/** eꗗ */
	private		HashMap<Node, Node>		mapShadow				= null;

	/**
	 * RXgN^
	 * @param application AvP[V
	 */
	public PRPanel3D(PRApplication application){

		// X[p[NXĂяo
		super();

		// AvP[Vێ
		this.application = application;

		// Ăяo
		init();

	} // end PRPanel3D

	/**
	 * 
	 * <pre>
	 * plNX̏s܂B
	 * </pre>
	 */
	public void init(){

		// e}bv𐶐
		mapShadow = new HashMap<Node, Node>();

	} // end init

	/**
	 * Jn
	 * <pre>
	 * IuWFNg̏Jn܂B
	 * </pre>
	 */
	public void start(){

	}

	/**
	 * s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void run(){

		// AvP[V̎s\bhĂяo
		boolean flgPlaying = application.isPlaying();

		// Q[̏ꍇA
		if(flgPlaying){

			//
			// m[h
			//

			// m[hꗗ擾
			List<Node> nodeLst = this.getNodeLst();

			// m[hꗗ̌擾
			int countNodeLst = nodeLst.size();

			// m[hꗗ̌A[v
			for(int j = 0; j < countNodeLst; j++){

				// m[h擾
				Node node = nodeLst.get(j);

				// _~[m[h̏ꍇA
				if(node instanceof PRNodeDummy){

					// ReBj[
					continue;

				// ȅꍇA
				}else if(node instanceof PRSpriteShadow){

					// ReBj[
					continue;

				// XvCg̏ꍇA
				}else if(node instanceof PRSprite){

					// XvCg擾
					PRSprite sprite = (PRSprite)node;

					// Փ˒H
					boolean flgBump = application.isBump();

					// Փ˒  vC[ł͂ȂꍇA
					if(flgBump && !(sprite instanceof PRSpritePrusher)){

						// ReBj[
						continue;

					}

					// XvCgs
					sprite.run();

					// eꍇA
					if(mapShadow.containsKey(sprite)){

						// e擾
						PRSpriteShadow spriteShadow = (PRSpriteShadow)mapShadow.get(sprite);

						// XvCgs
						spriteShadow.run();

					}

				} // end if XvCg̏ꍇ

			} // end for m[hꗗ̌A[v

		} // end if Q[̏ꍇi|[Ył͂Ȃꍇj

	} // end run

	/**
	 * |̎
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void clean(){

		//
		// m[hꗗȂꍇ́A|Bih~j
		// m[h̎sƂ͕ʂɂiUj
		//

		// m[hꗗ擾
		ObservableList<Node> nodeLst = this.getNodeLst();

		// m[hꗗ̌擾
		int countNodeLst = nodeLst.size();

		// m[hꗗ̌1000𒴂ꍇA
		if(countNodeLst > 1000){

			// ꎞIɃm[hꗗi[Nj쐬
			ArrayList<Node> nodeLstWk = new ArrayList<Node>(1000);

			// m[hꗗ̌A[v
			for(int j = 0; j < countNodeLst; j++){

				// m[h擾
				Node node = (Node)nodeLst.get(j);

				// m[h_~[m[hȊȌꍇA
				if(!(node instanceof PRNodeDummy)){

					// m[hꗗi[Njɒǉ
					nodeLstWk.add(node);

				}

			} // end for m[hꗗ̌A[v

			// m[hꗗւ
			nodeLst.setAll(nodeLstWk);

		} // end if m[hꗗ̌1000𒴂ꍇ

	} // end clean

	/**
	 * m[hǉ
	 * @param node m[h
	 */
	public void addNode(Node node){

		// m[hꗗ擾
		List<Node> nodeLst = this.getNodeLst();

		// m[hǉ
		nodeLst.add(node);

	} // end addNode

	/**
	 * m[h폜
	 * <pre>
	 * m[h폜܂B
	 * \bhł́A_~[m[hɒuArun\bh̒ō폜܂B
	 * nullɒułȂ
	 *  ListNXremove\bh𑽗p邱ƂŔzRs[𑽗p邱Ƃ邽
	 * idȂ邱Ƃł邾j
	 * </pre>
	 * @param node m[h
	 */
	public void removeNode(Node node){

		// m[hꗗ擾
		List<Node> nodeLst = this.getNodeLst();

		// CfbNX߂
		int index = nodeLst.indexOf(node);

		// CfbNX擾łꍇA
		if(index != -1){

			// _~[m[hɒu
			nodeLst.set(index, new PRNodeDummy(this.application));

		}

		// em[h폜
		// e݂ꍇ̂ݍ폜
		this.removeShadow(node);

	} // end removeNode

	/**
	 * em[hǉ
	 * <pre>
	 * em[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 */
	public void addShadow(Node node){

		// em[hǉ
		this.addShadow(node, -1);

	}

	/**
	 * em[hǉ
	 * <pre>
	 * em[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 * @param radius a
	 */
	public void addShadow(Node node, double radius){

		// e𐶐
		PRSpriteShadow spriteShadow = new PRSpriteShadow(application, node, radius);

		// 3DplNXĂяo
		this.addNode(spriteShadow);

		// eRt
		mapShadow.put(node, spriteShadow);

	}

	/**
	 * em[h폜
	 * <pre>
	 * em[h폜܂B
 	 * e݂ꍇ̂ݍ폜܂B
 	 * e݂Ȃꍇ͉܂iG[ɂ͂Ȃ܂jB
	 * </pre>
	 * @param sprite m[h
	 */
	public void removeShadow(Node node){

		// m[hꗗ擾
		List<Node> nodeLst = this.getNodeLst();

		// e݂ꍇA
		if(mapShadow.containsKey(node)){

			// CfbNX߂
			int index = nodeLst.indexOf(mapShadow.get(node));

			// CfbNX擾łꍇA
			if(index != -1){

				// eꗗ폜
				//  YƁA[[NƂȂB
				// eIuWFNgc܂܂ƂȂAHԂƂɂȂB
				mapShadow.remove(node);

				// _~[m[hɒu
				nodeLst.set(index, new PRNodeDummy(this.application));

			}

		} // end if e݂ꍇ

	} // end removeShadow

	/**
	 * m[hꗗ擾
	 * @return ObservableList<Node> m[hꗗ
	 */
	public ObservableList<Node> getNodeLst(){

		// List擾
		ObservableList<Node> nodeLst = this.getChildren();

		// ^[
		return nodeLst;

	} // end getNodeLst

	/**
	 * AvP[V擾
	 * @return PRApplication AvP[V
	 */
	public PRApplication getApplication(){

		// AvP[V^[
		return application;

	} // end getApplication

}
