import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.geometry.Point3D;
import javafx.scene.Node;

/**
 * bhEAC
 * <pre>
 * SKK畜oI
 * </pre>
 */
public class PRSpriteRedEye extends PRSpriteT {

	/** XvCgO[v */
	private		PRSpriteGroupRedEye		spriteGroup		= null;

	/** zup^[ */
	private		String					strPattern		= null;

	/** ]x */
	private		double					s				= 6;

	/**  */
	private		int						time			= 0;

	/** ̗ */
	private		int						strength		= 4;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteRedEye.class, "3d/RedEye.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spriteGroup XvCgO[v
	 * @param strPattern p^[
	 */
	public PRSpriteRedEye(PRApplication application, PRSpriteGroupRedEye spriteGroup, String strPattern){

		// X[p[NXĂяo
		super(application);

		try{

			// XvCgO[vێ
			this.spriteGroup = spriteGroup;

			// p^[ێ
			this.strPattern = strPattern;

			// Zݒ
			super.setTranslateZ(100);

			// IuWFNg
			ObjReader.create(this);

			// ]
			Point3D p = new Point3D(0.0, 1.0, 0.0);

			// ]ݒ
			super.setRotationAxis(p);

			// xݒ
			mz = -0.6;

			// eݒ
			application.addShadow(this, 0.6);

			// {X̏ꍇA
			if("{X".equals(strPattern)){

				// ̗͂6ɏグ
				strength = 6;

			}

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteRedEye

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// ]
		double angle = super.getRotate() % 360;
		angle = angle + this.s;
		super.setRotate(angle);

		// URp^[
		if("UR".equals(strPattern)){

			// W擾
			double z = super.getTranslateZ();

			// 2b
			if(time < 120){

				// WZ
				z = z + mz;

				// ړ
				super.setTranslateZ(z);

			// 3bE5.5bE8bE10.5b
			}if(time == 180 || time == 330 || time == 480 || time == 630){

				// G̃[U[𐶐
				PRSpriteLaserTeki1 spriteLaserTeki1 = new PRSpriteLaserTeki1(application, this, false);
				// G̃[U[ǉ
				application.addNode(spriteLaserTeki1);

				// G̃[U[PX^[g
				application.startWaveLaser1Teki();

			// 13b
			}else if(time < 780){

				// Ȃ

			// 7bȏ
			}else{

				// WZ
				z = z + mz;

				// ʂ̊OɂłꍇA
				if(z < 0){

					// 폜
					super.remove();
					// XvCgO[vɍ폜ʒm
					spriteGroup.removeSprite();

				}

				// ړ
				super.setTranslateZ(z);

			} // end if 

		// {Xp^[
		}else if("{X".equals(strPattern)){

			// W擾
			double z = super.getTranslateZ();

			// 2.5b
			if(time < 150){

				// WZ
				z = z + mz;

				// ړ
				super.setTranslateZ(z);

			// 2.0b
			}if(time % 120 == 0){

				// G̃[U[𐶐
				PRSpriteLaserTeki1 spriteLaserTeki1 = new PRSpriteLaserTeki1(application, this, true);
				// G̃[U[ǉ
				application.addNode(spriteLaserTeki1);

				// G̃[U[PX^[g
				application.startWaveLaser1Teki();

			} // end if 

		} // end if p^[

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// e֕ϊ
						PRSpriteTama spriteTama = (PRSpriteTama)node;

						// ˕ԂĂꍇA
						if(spriteTama.isRapel()){
							// ReBj[
							continue;
						}

						// px45`135܂225`315̏ꍇA
						if(angle > 45 && angle < 135 || angle > 225 && angle < 315){

							// e𒵂˕Ԃ
							spriteTama.rapel();

							// [v𔲂
							break;

						// LȊȌꍇA
						}else{

							// ̗́|P
							strength--;

							// e폜
							application.removeNode(node);

							// X^[g
							application.startWaveBomb();

							// ̗͂ȌꍇA
							if(strength <= 0){

								// 
								flgBomb = true;

								// 𐶐
								PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.05);

								// AvP[Vɔǉ
								application.addNode(spriteBomb);

								// _ǉ
								application.addScore(800);

								// XvCgO[vɍ폜ʒm
								spriteGroup.removeSprite();

							} // end if ̗͂O傫ꍇ

							// [v𔲂
							break;

						} // end if

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
