import javafx.geometry.Point3D;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.geometry.Bounds;

/**
 * 
 */
public class PRSpriteRock extends PRSpriteT {

	/** ]x */
	private		double			s			= Math.random() * 4 + 2;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteRock.class, "3d/Rock.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param stage Xe[W
	 */
	public PRSpriteRock(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// Xݒ
			double x = Math.random() * 24.0 - 12.0;

			// Xݒ
			super.setTranslateX(x);

			// Zݒ
			super.setTranslateZ(100);

			// IuWFNg
			ObjReader.create(this);

			// ]
			Point3D p = new Point3D(Math.random() - 0.5, Math.random() - 0.5, Math.random() - 0.5);

			// ]ݒ
			super.setRotationAxis(p);

			// g^k
			super.setScaleX(0.25);
			super.setScaleY(0.25);
			super.setScaleZ(0.25);

			// xݒ
			mz = -0.6;

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteRock

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		double x = super.getTranslateX();
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateZ(z);

		// ]
		super.setRotate(getRotate() + this.s);

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 
						flgBomb = true;

						// e폜
						application.removeNode(node);

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(100);

						// X^[g
						application.startWaveBomb();

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.2;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.2;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
