import java.util.HashMap;

import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.scene.Group;
import javafx.geometry.Bounds;
import javafx.scene.transform.Translate;
import javafx.scene.transform.Rotate;
import javafx.scene.shape.MeshView;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;

import javafx.event.EventType;
import javafx.event.EventHandler;

/**
 * ^ S iSj
 * <pre>
 * dlǂǂǉĂ̂ŁA
 * vOIɂ́AЂ傤Ɍɂ̂ƂȂĂ܂܂B
 * i^CłĂHIIj
 * ܂肢vOł͂ȂƂAł`Ă܂B
 * ʋtƂłAvĂB
 * ₷Aǂ݂₷vOɐSĂ܂傤
 * ̘bAC̉]Ȃ߂ǂB͂B
 * </pre>
 */
public class PRSpriteBattleShip extends PRSpriteT {

	/** ϋvx */
	private 	int						LIFE					= 200;

	/** b̐F */
	private static final Color			COLOR_ARMOR				= Color.color(0.8, 0.3, 0.3);

	/** tF[Y */
	private		int						phase					= 0;

	/** { */
	private		double					scale					= 1.0;

	/** W */
	private 	double					x						= 0.0;
	private 	double					y						= 0.0;
	private 	double					z						= 0.0;

	/**  */
	private 	int						time					= 0;

	/** px */
	private		int						angle					= 0;
	private		double[]				angleCannons			= {180, 180, 0};

	/** ː */
	private		int[]					phaseCannons			= {0, 0, 0};
	private		int[]					timeCannons				= {180, 240, 300};

	/** ϋvx */
	private 	int						life					= LIFE;

	/** ړ */
	private		int						way						= 1;

	/** ҂ */
	private		int						timeWait				= 0;

	/** G̒eˎ */
	private		int						timeTamaTeki			= 240;

	/** C */
	private		Group[]					groupCannons			= null;

	/** }eA */
	private		PhongMaterial			materail				= null;

	/** ̐F */
	private		Color					colorDefault			= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteBattleShip.class, "3d/BattleShip.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteBattleShip(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			HashMap<String, Group> map = ObjReader.create(this);

			// k
			super.setScaleX(scale);
			super.setScaleY(scale);
			super.setScaleZ(scale);

			// Wݒ
			x = 0.0;
			y = -2.0;
			z = 300.0;

			// xݒ
			mz = -2.0;

			// Cێ
			groupCannons = new Group[3];
			groupCannons[0] = map.get("Cannon001");
			groupCannons[1] = map.get("Cannon002");
			groupCannons[2] = map.get("Cannon003");

			// Cʒu␳
			// ]ɍ킹Ĉړ
			groupCannons[0].getTransforms().add(new Translate( 1.8, 0.0, 0.0));
			groupCannons[1].getTransforms().add(new Translate( 0.4, 0.0, 0.0));
			groupCannons[2].getTransforms().add(new Translate(-3.4, 0.0, 0.0));

			// ̈ʒuֈړ
			groupCannons[0].setTranslateX(x - 1.0);
			groupCannons[1].setTranslateX(x - 0.2);
			groupCannons[2].setTranslateX(x + 1.7);

			super.setTranslateX(x);
			super.setTranslateY(y);
			super.setTranslateZ(z);

			// ]ݒ
			this.setRotationAxis(Rotate.Y_AXIS);

			// C䐔A[v
			for(int i = 0; i < 3; i++){

				// C[hWnɍĔzu
				this.getChildren().remove(groupCannons[i]);
				application.addNode(groupCannons[i]);

				// k
				groupCannons[i].setScaleX(scale);
				groupCannons[i].setScaleY(scale);
				groupCannons[i].setScaleZ(scale);

				// 
				groupCannons[i].setTranslateY(y);
				groupCannons[i].setTranslateZ(z);

				// ]ݒ
				groupCannons[i].setRotationAxis(Rotate.Y_AXIS);

			} // end for C䐔A[v

			// O[vEbVr[擾
			Group group = map.get("Body");
			MeshView meshView = (MeshView)(group.getChildren().get(0));

			// }eA擾
			materail = (PhongMaterial)meshView.getMaterial();

			// ̐F擾
			colorDefault = materail.getDiffuseColor();

			// eݒ
			application.addShadow(this, 3.0);

			// Xg[[~
			application.getPRStoryPrusher().stop();

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteBattleShip

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		this.time++;

		// tF[YȌꍇA
		if(phase == 0){

			// WZ
			z = z + mz;

			// ړ
			super.setTranslateZ(z);

			// ~ʒuɗꍇA
			if(z <= 40){

				// tF[YP
				phase = 1;

				// ړ
				super.setTranslateZ(40);

				// SBGMX^[g
				application.startMP3BGMBattleShip();

			}

		// tF[YQAȐꍇA
		}else if(phase == 2 || phase == 3){

			// ]
			angle = time / 3;

			// ]120𒴂A
			if(phase == 2 && angle > 120){
				// tF[YR
				phase = 3;
			}

			// ]280𒴂A
			if(angle > 280){

				// tF[YS
				phase = 4;

				// xݒ
				mx = -0.04;
				mz = -0.2;

			}

			// ]
			this.setRotate(angle);
			x = 10 * Math.cos((-angle - 90) * 3.141592 / 180);
			z = 60 + 20 * Math.sin((-angle - 90) * 3.141592 / 180);

			// ړ
			super.setTranslateX(x);
			super.setTranslateZ(z);

		// tF[YSꍇA
		}else if(phase == 4){

			// WZ
			x = x + mx;
			z = z + mz;

			// ړ
			super.setTranslateX(x);
			super.setTranslateZ(z);

			// ʂ̊OɂłꍇA
			if(z <= -5.0){

				// SBGMXgbv
				application.stopMP3BGMBattleShip();

				// Xg[[ĊJ
				application.getPRStoryPrusher().start();

				// 폜
				super.remove();

			} // end if ʂ̊Oɂłꍇ

		} // end if tF[Y

		// CP݂ꍇA
		if(groupCannons[0] != null){

			// C擾
			Group groupCannon = groupCannons[0];

			// ʒu␳
			groupCannon.setTranslateX(x - 2.0 * Math.cos(angle * 3.141592 / 180));
			groupCannon.setTranslateY(y);
			groupCannon.setTranslateZ(z + 2.0 * Math.sin(angle * 3.141592 / 180));

			// ]
			groupCannon.setRotate(angleCannons[0]);

		} // end if CP݂ꍇ

		// CQ݂ꍇA
		if(groupCannons[1] != null){

			// C擾
			Group groupCannon = groupCannons[1];

			// ʒu␳
			groupCannon.setTranslateX(x - 0.4 * Math.cos(angle * 3.141592 / 180));
			groupCannon.setTranslateY(y);
			groupCannon.setTranslateZ(z - 0.4 * Math.sin(angle * 3.141592 / 180));

			// ]
			groupCannon.setRotate(angleCannons[1]);

		} // end if CQ݂ꍇ

		// CR݂ꍇA
		if(groupCannons[1] != null){

			// C擾
			Group groupCannon = groupCannons[2];

			// ʒu␳
			groupCannon.setTranslateX(x + 3.4 * Math.cos(angle * 3.141592 / 180));
			groupCannon.setTranslateY(y);
			groupCannon.setTranslateZ(z - 3.4 * Math.sin(angle * 3.141592 / 180));

			// ]
			groupCannon.setRotate(angleCannons[2]);

		} // end if CR݂ꍇ

		// C䕪A[v
		for(int i = 0; i < 3; i++){

			// tF[Y|C䂪UꍇA
			if(phase == 1 ||
				phase == 2 && i == 2 ||
				phase == 3 && (i == 0 || i == 1) ||
				phase == 4 && (i == 0 || i == 1)){

				// C擾
				Group groupCannon = groupCannons[i];

				// C䂪݂ȂꍇA
				if(groupCannons[0] == null){
					// ReBj[
					continue;
				}

				// px擾
				double angleCannon = angleCannons[i];
				angleCannon = (angleCannon >= 0)?angleCannon: angleCannon + 360;
				angleCannon = (angleCannon <= 360)?angleCannon: angleCannon - 360;

				// CtF[YȌꍇA
				if(phaseCannons[i] == 0){

					//
					// Cpxݒ
					//

					// W擾
					double xCannon = groupCannon.getTranslateX();
					double zCannon = groupCannon.getTranslateZ();

					// vC[擾
					PRSpritePrusher spritePrusher = application.getPRSpritePrusher();

					// W擾
					double xPrusher = spritePrusher.getTranslateX();
					double zPrusher = spritePrusher.getTranslateZ();

					// WA擾
					// Z͉֍sقǃvXɂȂ̂ŁAvZAtɂ
					double rad = Math.atan2(zCannon - zPrusher, xPrusher - xCannon);

					// px擾
					double angleP = rad * 180 / Math.PI;
					angleP = (angleP >= 0)?angleP: angleP + 360;
					angleP = (angleP <= 360)?angleP: angleP - 360;

					// 3xȓ
					if(Math.abs(angleP - angleCannon) < 3.0){

						// Ȃ

					// 3xȏ
					}else{

						// px߂
						double angleSa = angleP - angleCannon;

						// vX̏ꍇA
						if(angleSa > 0){
							// +2x
							angleCannon = angleCannon + 1;
						// LȊȌꍇA
						}else{
							// -2x
							angleCannon = angleCannon - 1;
						}

						// px␳
						angleCannon = (angleCannon >= 0)?angleCannon: angleCannon + 360;
						angleCannon = (angleCannon <= 360)?angleCannon: angleCannon - 360;

						// pxݒ
						angleCannons[i] = angleCannon;

					} // end if

				} // end if CtF[YȌꍇ

				//
				// ː
				//

				// ԁ|P
				timeCannons[i]--;

				// ԂoꍇA
				if(timeCannons[i] <= 0){

					// CtF[YȌꍇA
					if(phaseCannons[i] == 0){

						// G̒e𐶐
						PRSpriteGroupLaserTeki2 spriteGroupTamaTeki = new PRSpriteGroupLaserTeki2(application, groupCannon);
						// G̒eǉ
						application.addSpriteGroup(spriteGroupTamaTeki);

						// tF[YP
						phaseCannons[i] = 1;

						// ԏ
						timeCannons[i] = 180 - ((phase == 2 || phase == 3 || phase == 4)?150: 0);

					// CtF[YP̏ꍇA
					}else if(phaseCannons[i] == 1){

						// tF[YQ
						phaseCannons[i] = 2;

						// ԏ
						timeCannons[i] = 120 - ((phase == 2 || phase == 3 || phase == 4)?90: 0);

					// CtF[YQ̏ꍇA
					}else if(phaseCannons[i] == 2){

						// tF[YR
						phaseCannons[i] = 3;

						// ԏ
						timeCannons[i] = 60;

					// CtF[YȐꍇA
					}else if(phaseCannons[i] == 3){

						// tF[YO
						phaseCannons[i] = 0;

						// ԏ
						timeCannons[i] = (int)(Math.random() * 60);

					} // end if CtF[Y

				} // end if Ԃoꍇ

			} // end if tF[Y|C䂪Uꍇ

		} // end for C䕪A[v

		// tF[YOAPAQAȐꍇA
		if(phase == 0 || phase == 1 || phase == 2 || phase == 3){

			// 10
			if(Math.random() < 0.10){

				// G̒e𐶐
				PRSpriteTamaTeki3 spriteTama = new PRSpriteTamaTeki3(application, this, 1.0 - Math.random() * 2.0);
				// G̒eǉ
				application.addNode(spriteTama);

			} // end if m

		} // end if tF[Y

		// tF[YOAP̏ꍇA
		if(phase == 0 || phase == 1){

			// Ԃ
			if(time % 360 == 0){

				// AXeC_[XvCgO[v𐶐
				PRSpriteGroupShip spriteGroup = new PRSpriteGroupShip(application, "S");

				// AvP[VɃXvCgO[vǉ
				application.addSpriteGroup(spriteGroup);

			}

		} // end if tF[Y

		//
		// 蔻
		//

		// tF[YP̏ꍇA
		if(phase == 1){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// e֕ϊ
						PRSpriteTama spriteTama = (PRSpriteTama)node;

						// ˕ԂĂꍇA
						if(spriteTama.isRapel()){
							// ReBj[
							continue;
						}

						// e𒵂˕Ԃ
						spriteTama.rapel();

						// ϋvx|P
						life--;

						// ϋvxPɂȂꍇA
						if(life <= 1){

							// tF[YQ
							phase = 2;

							// ԏ
							time = 0;

						}

						// lꍇA
						if(life % 4 == 0){

							// X^[g
							application.startWaveBomb();

						}

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

			// ԂA
			if(life != LIFE && time % life < 2){

				// b̐F̐ݒ
				materail.setDiffuseColor(COLOR_ARMOR);
				materail.setSpecularColor(COLOR_ARMOR);

			// LȊȌꍇA
			}else{

				// Fɖ߂
				materail.setDiffuseColor(colorDefault);
				materail.setSpecularColor(colorDefault);

			}

		} // end if tF[YP̏ꍇ

	} // end run

	/**
	 * 폜
	 * <pre>
	 * C䂪ʃO[vɏ悤ɂĂ邽߁A
	 * ʃO[vC폜鏈ǉĂ܂B
	 * </pre>
	 */
	public void remove(){

		// C䐔A[v
		for(int i = 0; i < 3; i++){
			// C[hWn폜
			application.removeNode(groupCannons[i]);
		}

		// X[p[NX̍폜\bhĂяo
		super.remove();

	} // end remove

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.4;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.4;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
