import java.util.StringTokenizer;
import javafx.scene.shape.Sphere;
import javafx.scene.paint.PhongMaterial;
import javafx.geometry.Bounds;
import javafx.scene.paint.Color;

/**
 * _
 */
public class PRSpriteCloud extends PRSprite {

	/** }eA */
	private static		PhongMaterial	material	= null;

	/** [vtO */
	private				boolean			flgLoop		= true;

	/** XW */
	private				double			x			= 0.0;

	/** XX */
	private				double			xDefault	= 0.0;

	/**
	 * 
	 */
	public static void init() {

		try{
			// }eA𐶐
			material = new PhongMaterial();
			material.setDiffuseColor(Color.color(0.8, 0.8, 0.8, 0.3));

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteCloud(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// 傫ݒ
			double size = Math.random() * 10 + 5;

			// _̐ݒ
			int count = (int)(size * 2);

			// _̐A[v
			for(int i = 0; i < count; i++){

				// 𐶐
				Sphere sphere = new Sphere((Math.random() / 2 + 0.5) * size * 0.10, 12);

				// }eAo^
				sphere.setMaterial(material);

				// ǉ
				this.getChildren().add(sphere);

				// ̈ʒuݒ
				sphere.setTranslateX((Math.random() - 0.50) * size * 0.50);
				sphere.setTranslateY((Math.random() - 0.50) * size * 0.05);
				sphere.setTranslateZ((Math.random() - 0.50) * size * 0.50);

			} // end for _̐A[v

			// Xݒ
			xDefault = Math.random() * 30.0 - 15.0;
			x = xDefault;
			super.setTranslateX(x);

			// Yݒ
			Bounds bounds = this.getBoundsInParent();
			super.setTranslateY(bounds.getHeight() / 2);

			// Zݒ
			super.setTranslateZ(200);

			// xݒ
			mz = -2.0;

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteCloud

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param strParam zup^[
	 */
	public PRSpriteCloud(PRApplication application, String strParam){

		// X[p[NXĂяo
		super(application);

		try{

			//
			// p[^evf擾
			//

			// g[N쐬
			StringTokenizer stParam = new StringTokenizer(strParam, " ");

			// 傫擾
			double size = Double.parseDouble(stParam.nextToken());

			// XW
			x = Double.parseDouble(stParam.nextToken());

			// YW
			double y = Double.parseDouble(stParam.nextToken());

			//
			// _𐶐
			//

			// _̐ݒ
			int count = (int)(size * 5);

			// _̐A[v
			for(int i = 0; i < count; i++){

				// 𐶐
				Sphere sphere = new Sphere((Math.random() / 2 + 0.5) * size * 0.10, 16);

				// }eAo^
				sphere.setMaterial(material);

				// ǉ
				this.getChildren().add(sphere);

				// ̈ʒuݒ
				sphere.setTranslateX((Math.random() - 0.50) * size * 0.50);
				sphere.setTranslateY((Math.random() - 0.50) * size * 0.10);
				sphere.setTranslateZ((Math.random() - 0.50) * size * 0.50);

			} // end for e̐A[v

			// Xݒ
			super.setTranslateX(x);

			// Yݒ
			super.setTranslateY(y);

			// Zݒ
			super.setTranslateZ(200);

			// xݒ
			mz = -2.0;

			// [v͂Ȃ
			flgLoop = false;

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteCloud

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 2){

			// [vꍇA
			if(flgLoop){

				// ʒu߂
				x = xDefault;
				z = 200;

			// [vȂꍇA
			}else{

				// 폜
				super.remove();

			}

		} // end if ʂ̊Oɂłꍇ

		// ړ
		super.setTranslateZ(z);

	} // end run

	/**
	 * I
	 * <pre>
	 * _I܂B
	 * <pre>
	 */
	public void finish(){

		// [v~
		flgLoop = false;

	} // end finish

}
