import java.io.File;

import javafx.scene.Group;;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;
import javafx.scene.image.Image;

import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.shape.DrawMode;

import javafx.scene.transform.Rotate;
import javafx.geometry.Point3D;

import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.scene.Node;

/**
 * L[
 * <pre>
 * OBjReaderg킸ɁAꂩ3DIuWFNgAL[oꂳ܂B
 * ́AV[eBOQ[ҁiJavaŃQ[낤Pj̓ołB
 * ̃IuWFNǵA킽g׋邽߂ɁABƂjƂAȁB
 * Ȃ̂A肵܂B
 * OtpɍWƂāAςłB
 * ̓c[gȂƖȁEEEƁAʂƂȂ܂B
 * iBlenderwԂȂEEEāj
 * ́ÃIuWFNĝŁAoꂳ܂B
 * i̘błj
 * </pre>
 */
public class PRSpriteKirar extends PRSpriteT {

	/** C[W */
	private static Image		image		= null;

	private final int			P_1_0_0		=  0;
	private final int			P_2_0_0		=  1;
	private final int			P_3_0_0		=  2;
	private final int			P_4_0_0		=  3;
	private final int			P_5_0_0		=  4;
	private final int			P_6_0_0		=  5;

	private final int			P_1_1_0		=  6;
	private final int			P_2_1_0		=  7;
	private final int			P_3_1_0		=  8;
	private final int			P_4_1_0		=  9;
	private final int			P_5_1_0		= 10;
	private final int			P_6_1_0		= 11;

	private final int			P_0_0_1		= 12;
	private final int			P_2_1_1		= 13;
	private final int			P_5_1_1		= 14;
	private final int			P_7_0_1		= 15;

	private final int			P_0_0_3		= 16;
	private final int			P_1_1_3		= 17;
	private final int			P_2_1_3		= 18;
	private final int			P_3_1_3		= 19;
	private final int			P_4_1_3		= 20;
	private final int			P_5_1_3		= 21;
	private final int			P_6_1_3		= 22;
	private final int			P_7_0_3		= 23;

	private final int			P_1_0_4		= 24;
	private final int			P_6_0_4		= 25;

	private final int			P_2_0_5		= 26;
	private final int			P_5_0_5		= 27;

	private final int			P_3_0_6		= 28;
	private final int			P_4_0_6		= 29;

	private final int			P_2_2_1		= 30;
	private final int			P_5_2_1		= 31;

	private final int			P_2_2_2		= 32;
	private final int			P_5_2_2		= 33;
	private final int			P_2_1_2		= 34;
	private final int			P_5_1_2		= 35;

	private			float[]		points = {
		-1.5f,  0.5f,  2.0f,
		-1.0f,  0.5f,  2.0f,
		-0.5f,  0.5f,  2.0f,
		 0.5f,  0.5f,  2.0f,
		 1.0f,  0.5f,  2.0f,
		 1.5f,  0.5f,  2.0f,

		-1.5f,  0.0f,  2.0f,
		-1.0f,  0.0f,  2.0f,
		-0.5f,  0.0f,  2.0f,
		 0.5f,  0.0f,  2.0f,
		 1.0f,  0.0f,  2.0f,
		 1.5f,  0.0f,  2.0f,

		-2.0f,  0.5f,  1.0f,
		-1.0f,  0.0f,  1.0f,
		 1.0f,  0.0f,  1.0f,
		 2.0f,  0.5f,  1.0f,

		-2.0f,  0.5f, -1.0f,
		-1.5f,  0.0f, -1.0f,
		-1.0f,  0.0f, -1.0f,
		-0.5f,  0.0f, -1.0f,
		 0.5f,  0.0f, -1.0f,
		 1.0f,  0.0f, -1.0f,
		 1.5f,  0.0f, -1.0f,
		 2.0f,  0.5f, -1.0f,

		-1.5f,  0.5f, -1.5f,
		 1.5f,  0.5f, -1.5f,

		-1.0f,  0.5f, -2.0f,
		 1.0f,  0.5f, -2.0f,

		-0.5f,  0.5f, -2.5f,
		 0.5f,  0.5f, -2.5f,

		-1.0f, -0.5f,  1.0f,
		 1.0f, -0.5f,  1.0f,

		-1.0f, -0.5f,  0.0f,
		 1.0f, -0.5f,  0.0f,
		-1.0f,  0.0f,  0.0f,
		 1.0f,  0.0f,  0.0f,

	};

	/** O[ */
	private final int[]			faces_0 = {
		P_1_1_0, 0, P_0_0_1, 0, P_1_1_3, 0,
		P_0_0_1, 0, P_0_0_3, 0, P_1_1_3, 0,
		P_6_1_0, 0, P_6_1_3, 0, P_7_0_3, 0,
		P_6_1_0, 0, P_7_0_3, 0, P_7_0_1, 0,
		P_2_1_1, 0, P_2_1_3, 0, P_5_1_3, 0,
		P_2_1_1, 0, P_5_1_3, 0, P_5_1_1, 0,
		P_0_0_3, 0, P_1_0_4, 0, P_1_1_3, 0,
		P_6_1_3, 0, P_6_0_4, 0, P_7_0_3, 0,
		P_2_1_3, 0, P_2_0_5, 0, P_3_0_6, 0,
		P_2_1_3, 0, P_3_0_6, 0, P_3_1_3, 0,
		P_4_1_3, 0, P_4_0_6, 0, P_5_0_5, 0,
		P_4_1_3, 0, P_5_0_5, 0, P_5_1_3, 0,
		P_3_1_3, 0, P_3_0_6, 0, P_4_0_6, 0,
		P_3_1_3, 0, P_4_0_6, 0, P_4_1_3, 0,

		// 㕔
		P_2_2_1, 0, P_2_2_2, 0, P_5_2_2, 0,
		P_2_2_1, 0, P_5_2_2, 0, P_5_2_1, 0,
		P_5_2_1, 0, P_5_1_1, 0, P_2_1_1, 0,
		P_5_2_1, 0, P_2_1_1, 0, P_2_2_1, 0,

		// 
		P_2_2_1, 0, P_2_1_1, 0, P_2_1_2, 0,
		P_2_2_1, 0, P_2_1_2, 0, P_2_2_2, 0,
		P_5_2_2, 0, P_5_1_2, 0, P_5_1_1, 0,
		P_5_2_2, 0, P_5_1_1, 0, P_5_2_1, 0,

		// w
		P_4_1_0, 0, P_4_0_0, 0, P_3_0_0, 0,
		P_4_1_0, 0, P_3_0_0, 0, P_3_1_0, 0,
		P_6_1_0, 0, P_7_0_1, 0, P_6_0_0, 0,
		P_1_1_0, 0, P_1_0_0, 0, P_0_0_1, 0,

		// 
		P_5_0_0, 0, P_5_0_5, 0, P_2_0_5, 0,
		P_5_0_0, 0, P_2_0_5, 0, P_2_0_0, 0,
		P_5_0_5, 0, P_4_0_6, 0, P_3_0_6, 0,
		P_5_0_5, 0, P_3_0_6, 0, P_2_0_5, 0,

		P_1_0_0, 0, P_1_0_4, 0, P_0_0_3, 0,
		P_1_0_0, 0, P_0_0_3, 0, P_0_0_1, 0,
		P_6_0_0, 0, P_7_0_1, 0, P_7_0_3, 0,
		P_6_0_0, 0, P_7_0_3, 0, P_6_0_4, 0,

	};

	/**  */
	private final int[]			faces_1 = {
		P_2_2_2, 0, P_3_1_3, 0, P_4_1_3, 0,
		P_2_2_2, 0, P_4_1_3, 0, P_5_2_2, 0,
		P_2_2_2, 0, P_2_1_2, 0, P_3_1_3, 0,
		P_5_2_2, 0, P_4_1_3, 0, P_5_1_2, 0,
		P_1_1_0, 0, P_1_1_3, 0, P_2_1_3, 0,
		P_1_1_0, 0, P_2_1_3, 0, P_2_1_0, 0,
		P_5_1_0, 0, P_5_1_3, 0, P_6_1_3, 0,
		P_5_1_0, 0, P_6_1_3, 0, P_6_1_0, 0,
		P_1_1_3, 0, P_1_0_4, 0, P_2_0_5, 0,
		P_1_1_3, 0, P_2_0_5, 0, P_2_1_3, 0,
		P_5_1_3, 0, P_5_0_5, 0, P_6_0_4, 0,
		P_5_1_3, 0, P_6_0_4, 0, P_6_1_3, 0,
		P_6_1_0, 0, P_6_0_0, 0, P_5_0_0, 0,
		P_6_1_0, 0, P_5_0_0, 0, P_5_1_0, 0,
		P_2_1_0, 0, P_2_0_0, 0, P_1_0_0, 0,
		P_2_1_0, 0, P_1_0_0, 0, P_1_1_0, 0,
		P_2_0_0, 0, P_2_0_5, 0, P_1_0_4, 0,
		P_2_0_0, 0, P_1_0_4, 0, P_1_0_0, 0,
		P_6_0_0, 0, P_6_0_4, 0, P_5_0_5, 0,
		P_6_0_0, 0, P_5_0_5, 0, P_5_0_0, 0,

	};

	/** ԕ */
	private final int[]			faces_2 = {
		P_5_1_0, 0, P_5_0_0, 0, P_4_0_0, 0,
		P_5_1_0, 0, P_4_0_0, 0, P_4_1_0, 0,
		P_3_1_0, 0, P_3_0_0, 0, P_2_0_0, 0,
		P_3_1_0, 0, P_2_0_0, 0, P_2_1_0, 0,
	};

	/** eNX` */
	private final int[]			faces_3 = {
		P_2_1_0, 0, P_2_1_1, 1, P_5_1_1, 2,
		P_2_1_0, 0, P_5_1_1, 2, P_5_1_0, 3
	};

	/** _~[eNX` */
	private final float[]		texCoords = {
		0, 0
	};

	/** eNX` */
	private final float[]		texCoords_3 = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	/** rC */
	private final Color[]		COLORS = {
		Color.color(0.4, 0.0, 0.0),
		Color.color(0.5, 0.0, 0.0),
		Color.color(0.6, 0.0, 0.0),
		Color.color(0.7, 0.0, 0.0),
		Color.color(0.8, 0.0, 0.0),
		Color.color(0.9, 0.0, 0.0),
		Color.color(1.0, 0.0, 0.0)
	};

	/** bVr[ */
	private		MeshView			meshView0		= null;
	private		MeshView			meshView1		= null;
	private		MeshView			meshView2		= null;
	private		MeshView			meshView3		= null;

	/** }eA */
	private		PhongMaterial		material0		= null;
	private		PhongMaterial		material1		= null;
	private		PhongMaterial		material2		= null;
	private		PhongMaterial		material3		= null;

	/** XvCgO[v */
	private		PRSpriteGroupKirar	spriteGroup		= null;

	/**  */
	private		int					time			= 0;

	/** e𔭎˂^C~OBoĂ̎ԂݒB-1͔˂ȂB */
	private		int					timeTama		= -1;

	/**
	 * 
	 */
	public static void init() {

		// eNX`摜쐬
		String filePath = new File("imagePRSpriteKirar.jpg").toURI().toString();
		PRSpriteKirar.image = new Image(filePath);

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spriteGroup O[v
	 * @param pos |WV
	 * @param timeTama e𔭎˂^C~OBoĂ̎ԂݒB-1͔˂ȂB
	 */
	public PRSpriteKirar(PRApplication application, PRSpriteGroupKirar spriteGroup, int pos, int timeTama){

		// X[p[NXĂяo
		super(application);

		// XvCgO[vێ
		this.spriteGroup = spriteGroup;

		// e𔭎˂^C~Oێ
		this.timeTama = timeTama;

		//
		// O[
		//

		// bVr[쐬
		meshView0 = new MeshView();

		// bV쐬
		TriangleMesh mesh0 = new TriangleMesh();

		mesh0.getPoints().addAll(points);
		mesh0.getTexCoords().addAll(texCoords);
		mesh0.getFaces().addAll(faces_0);

		// }eA쐬
		material0 = new PhongMaterial();
		material0.setDiffuseColor(Color.web("808080"));

		// bVo^
		meshView0.setMesh(mesh0);
		meshView0.setMaterial(material0);

		// bVr[ǉ
		this.getChildren().add(meshView0);

		//
		// 
		//

		// bVr[쐬
		meshView1 = new MeshView();

		// bV쐬
		TriangleMesh mesh1 = new TriangleMesh();

		mesh1.getPoints().addAll(points);
		mesh1.getTexCoords().addAll(texCoords);
		mesh1.getFaces().addAll(faces_1);

		// }eA쐬
		material1 = new PhongMaterial();
		material1.setDiffuseColor(Color.web("000060"));

		// bVo^
		meshView1.setMesh(mesh1);
		meshView1.setMaterial(material1);

		// bVr[ǉ
		this.getChildren().add(meshView1);

		//
		// ԕ
		//

		// bVr[쐬
		meshView2 = new MeshView();

		// bV쐬
		TriangleMesh mesh2 = new TriangleMesh();

		mesh2.getPoints().addAll(points);
		mesh2.getTexCoords().addAll(texCoords);
		mesh2.getFaces().addAll(faces_2);

		// }eA쐬
		material2 = new PhongMaterial();
		material2.setDiffuseColor(Color.web("800000"));

		// bVo^
		meshView2.setMesh(mesh2);
		meshView2.setMaterial(material2);

		// bVr[ǉ
		this.getChildren().add(meshView2);

		//
		// eNX`
		//

		// bVr[쐬
		meshView3 = new MeshView();

		// bV쐬
		TriangleMesh mesh3 = new TriangleMesh();

		mesh3.getPoints().addAll(points);
		mesh3.getTexCoords().addAll(texCoords_3);
		mesh3.getFaces().addAll(faces_3);

		// }eA쐬
		PhongMaterial material3 = new PhongMaterial();
		material3.setDiffuseMap(PRSpriteKirar.image);

		// bVo^
		meshView3.setMesh(mesh3);
		meshView3.setMaterial(material3);

		// bVr[ǉ
		this.getChildren().add(meshView3);

		// ]ݒ
		super.setRotationAxis(Rotate.X_AXIS);

		// g^k
		super.setScaleX(0.25);
		super.setScaleY(0.25);
		super.setScaleZ(0.25);

		// Wݒ
		super.setTranslateX((pos - 2) * 1.2);
		super.setTranslateY(-1.5);
		super.setTranslateZ(300);

	} // end PRSpriteKirar

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// W擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		//
		// ړ
		//

		// 2.41666cbiZʒu10̂Ƃ܂Łj
		if(time < 145){

			// ړ
			z = z - 2;

		// 2.91666cbi0.5bԁj
		}else if(time < 175){

			// ړ
			y = y - 0.06;

			// 2.41666cbiZʒu10̂Ƃj
			if(time == 145){

				// ʉX^[g
				spriteGroup.startWaveTurnKirar();

			}

		// LȊOA
		}else{

			// ړ
			z = z + 2;

			// ʂ̊OɂłꍇA
			if(z > 300){
				// 폜
				super.remove();
			}

		} // end if 

		// ړ
		super.setTranslateY(y);
		super.setTranslateZ(z);

		//
		// ]
		//

		// 2.41666cbiZʒu10̂Ƃ܂Łj
		if(time < 145){

			// Ȃ

		// 2.91666cb
		}else if(time < 175){

			// ]
			super.setRotate(super.getRotate() - 6);

		} // end if 

		//
		// ł镵͋C
		//

		// ԂA
		if(time % 8 == 0){

			// ł镵͋Co
			material2.setDiffuseColor(COLORS[((int)(Math.random() * 7))]);

		}

		//
		// G̒e
		//

		// G̒e𔭎˂ꍇA
		if(timeTama != -1){

			// ԁ|P
			timeTama--;

			// ԂA
			if(timeTama == 0){

				// G̒e𐶐
				PRSpriteTamaTeki1 spriteTamaTeki = new PRSpriteTamaTeki1(application, this, 1.0);
				// G̒eǉ
				application.addNode(spriteTamaTeki);

				// G̒eX^[g
				application.startWaveTamaTeki();

			}

		} // end if G̒e𔭎˂ĂȂꍇ

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 
						flgBomb = true;

						// e폜
						application.removeNode(node);

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.05);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(300);

						// X^[g
						application.startWaveBomb();

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

}
