import javafx.scene.Group;
import javafx.scene.shape.MeshView;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;

/**
 * e
 */
public class PRSpriteTama extends PRSprite {

	/** e̐F */
	private static final Color[]	COLOR_TAMA		= new Color[]{
		Color.color(0.8, 0.8, 0.6, 0.5),
		Color.color(0.6, 0.6, 0.3, 0.5),
		Color.color(0.4, 0.4, 0.0, 0.5),
		Color.color(0.0, 0.0, 0.0, 0.5),
		Color.color(0.4, 0.4, 0.0, 0.5),
		Color.color(0.6, 0.6, 0.3, 0.5),
		Color.color(0.8, 0.8, 0.6, 0.5)
	};

	/** }eA */
	private		PhongMaterial		materail		= null;

	/**  */
	private		int					time			= 0;

	/** ˕Ԃꂽ */
	private		boolean				flgRapel		= false;

	/** ˕ԂꂽXړ */
	private		double				mx				= 0;

	/** ˕ԂꂽYړ */
	private		double				my				= 0;

	/** bNGXvCg */
	private		PRSpriteT			spriteT			= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteTama.class, "3d/Tama.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spritePrusher vC[
	 * @param spriteT GXvCg
	 */
	public PRSpriteTama(PRApplication application, PRSpritePrusher spritePrusher, PRSpriteT spriteT) {

		super(application);

		// IuWFNg
		ObjReader.create(this);

		// GXvCgێ
		this.spriteT = spriteT;

		// ʒuݒ
		super.setTranslateX(spritePrusher.getTranslateX());
		super.setTranslateY(spritePrusher.getTranslateY() - 0.1);
		super.setTranslateZ(spritePrusher.getTranslateZ() + 1.0);

		// O[vEbVr[擾
		Group group = (Group)this.getChildren().get(0);
		MeshView meshView = (MeshView)(group.getChildren().get(0));

		// }eA擾
		materail = (PhongMaterial)meshView.getMaterial();

	} // end PRSpriteTama

	/**
	 * s
	 */
	@Override
	public void run(){

		// ˕ԂĂȂꍇA
		if(!flgRapel){

			// ʒu擾
			double z = super.getTranslateZ();

			// ړ
			z = z + 2;

			// ł
			if(z > 200){

				// 폜
				application.removeNode(this);

				// ^[
				return;

			}

			// bNIĂꍇA
			if(spriteT != null){

				// ĂꍇA
				if(spriteT.isBomb()){

					// bNIO
					spriteT = null;

				// ĂȂꍇA
				}else{

					// GXvCg̈ʒuɒe킹
					super.setTranslateX(spriteT.getTranslateX());
					super.setTranslateY(spriteT.getTranslateY());

				} // end if

			} // end if bNIĂꍇ

			// ʒuݒ
			super.setTranslateZ(z);

			// Ԑݒ
			time++;
			time = (time >= 7)?0: time;

			// e̐F̐ݒ
			materail.setDiffuseColor(COLOR_TAMA[time]);
			materail.setSpecularColor(COLOR_TAMA[time]);

		// ˕ԂꂽꍇA
		}else{

			// ʒu擾
			double x = super.getTranslateX();
			double y = super.getTranslateY();

			// ړ
			x = x + mx;
			y = y + my;

			// ł
			if(x < -20 || x > 20 || y < -10){

				// 폜
				application.removeNode(this);

			}

			// ʒuݒ
			super.setTranslateX(x);
			super.setTranslateY(y);

		} // end if ˕Ԃꂽꍇ

	} // end run

	/**
	 * ˕Ԃꂽ
	 */
	public void rapel(){

		// ˕Ԃꂽ
		flgRapel = true;

		// Xړ
		mx = (Math.random() - 0.5) / 2;

		// Yړ
		my = -(Math.random() * 0.5) / 2;

		// ˕Ԃ艹X^[g
		application.startWaveRapel();

	} // end rapel

	/**
	 * ˕ԂĂ邩
	 */
	public boolean isRapel(){
		return flgRapel;
	}

}
